
;   4DBGHELP.COM     2004-04-25     C. Dye     raster@highfiber.com
;
;   GPL free software.  Copyright 2004, Charles Dye.  No warranty!
;
;   This program examines the primary command shell's arguments
;   in an attempt to discover whether the system was started in
;   interactive mode.  It's intended for use with 4DOS v7.50,
;   which no longer honors /Y; but might conceivably be useful
;   in other shells.
;
;   If the primary shell's command tail contains an unquoted /Y
;   before any unquoted /C /K or /P, 4DBGHELP will return an exit
;   code of zero indicating that the batch debugger should be
;   activated.  If no /Y was found, if 4DBGHELP was not run from
;   the primary command shell, or if there was any other problem,
;   4DBGHELP returns exit code 1.  No allowance is made for
;   alternate switchars ( -Y -C -K -P ) or for startup commands
;   not preceded by /C /K or /P.  This utility might be used in
;   either AUTOEXEC.BAT or 4START.BTM like this:
;
;      c:\bin\4dos\4dbghelp && setdos /y1
;
;   This file is source code for Eric Isaacson's A86 assembler.
;   To reassemble, type:
;
;      a86 4dbghelp.s 4dbghelp.com +S +P64


radix 16


doscall macro                          ; call to dos int_21 with a
mov ah,#1                              ; one-byte function in ah
int 21
#em

doscall2 macro                         ; call to dos int_21 with a
mov ax,#1                              ; two-byte function in ax
int 21
#em


begin:
mov ax,1700
int 2f                                 ; is windows running?
cmp ax,1700                            ; if so, abort
jne abort
doscall2 352e                          ; get int 2e vector (shell backdoor)
mov ax,es
or  bx,ax                              ; is returned vector 0000:0000 ?
je abort                               ; if so, abort
cmp w [es:0000],20cd                   ; does target resemble a psp ?
jne abort                              ; if not, abort
cmp ax,w [000c]                        ; is the primary shell this program's
jne abort                              ; parent?  if not, abort
mov si,0080                            ; point to start of shell's arguments
mov cx,0001                            ; no double quotes found

main_loop:
inc si
cmp si,0100                            ; blown past the end of the psp ?
jae abort                              ; if so, abort
mov ax,[es:si]                         ; get next character from shell's args
and ah,0df                             ; uppercase the following letter
cmp al,0d
je abort                               ; found the end of the line ?
cmp al,00                              ; if so, abort
je abort
cmp al,'"'                             ; double quote ?
jne > l10                              ; if so,
xor cl,01                              ; toggle quote mode
l10:
jcxz main_loop                         ; if quote mode, skip following tests
cmp ax,'C' by '/'
je abort                               ; found a /C, abort
cmp ax,'K' by '/'
je abort                               ; found a /K, abort
cmp ax,'P' by '/'
je abort                               ; found a /P, abort
cmp ax,'Y' by '/'                      ; found a /Y ?
jne main_loop                          ; if not, continue parsing

doscall2 4c00                          ; /Y found :  exit with errorlevel 0

abort:                                 ; no /Y found :
doscall2 4c01                          ; exit with errorlevel 1



;   History:
;
;   2004-03-12    Original release
;
;   2004-04-25    Abort if Windows is detected

